SIDLOADPOS = $1000 ;
SIDPLAYPOS = $1003
SCREENRAM = $0400
		.segment "LOADADDR"
		.byte 01,08
			;include data (charsets, sprites, msx)


			.segment "MUSIC"
			.incbin "Alaska.sid",$7e
			
			.segment "TITLECHARSET"
			.incbin "title_charset.bin"
			
			.export _CHARSET_GAME
			.segment "CHARSET"
_CHARSET_GAME: 
			.incbin "hanoi_charset.bin"
			
			.export _TITLE_MAP
			.segment "TITLEMAP"
_TITLE_MAP:	.incbin "title_map.bin"
			
			.export _HANOI_MAP
			.segment "MAP"
_HANOI_MAP:	.incbin "hanoi_map.bin"
			
			.export _HANOI_ATTRIBUTES
			.segment "ATTRIBUTES"
_HANOI_ATTRIBUTES:	.incbin "hanoi_attributes.bin"

			.export _TITLE_ATTRIBUTES
			.segment "TITLEATTRIBUTES"
_TITLE_ATTRIBUTES:	.incbin "title_attributes.bin"
			
			.segment "SPRITES"
			.incbin "Sprites1.raw"

;_colortab:		.byte 1,1,2,5,6,4,7,3
;_highscore:		.res 160
;_matrix:		.res 64
;			.export _bmp_data
			;.segment "RODATA"
;_bmp_data:		.incbin "zootitle.pic"

			.segment "CODE"
			
;---------------------------------------------------------------------------------
;void makecolour(void);
;---------------------------------------------------------------------------------	
			.export _makecolour
_makecolour: 
;			lda #<_HANOI_ATTRIBUTES
;			ldx #>_HANOI_ATTRIBUTES
			sta $fb
			stx $fc
			ldx #$00
:			ldy SCREENRAM,x
			lda($fb),y
			sta $d800,x
			ldy SCREENRAM+$100,x
			lda($fb),y
			sta $d900,x
			ldy SCREENRAM+$200,x
			lda($fb),y
			sta $da00,x
			ldy SCREENRAM+$2e8,x
			lda($fb),y
			sta $dae8,x
			inx
			bne :-
			rts
				
;---------------------------------------------------------------------------------
;void fill(void);
;---------------------------------------------------------------------------------
			.export _fill

_fill:		lda #$ff
			ldx #0
:			sta $0400,x
			sta $0500,x
			sta $0600,x
			sta $06e8,x
			inx
			bne :-
			rts
;---------------------------------------------------------------------------------
;vpod gfx_mode(void);
;---------------------------------------------------------------------------------
			.export _gfx_mode

_gfx_mode:		 jsr _fill
			lda #$18
			sta $d016
			lda #$30
			jmp _setgfx
		
;---------------------------------------------
;void __fastcall__ setgfx(unsigned int);
;---------------------------------------------
			.export _setgfx

_setgfx:		ldx #4
			ldy #0
			sty d1
			asl
			rol d1
			asl
			rol d1
			sta tmp
			txa
			lsr
			lsr
			ldx #4
loop1:			asl tmp
			rol
			dex
			bne loop1
			sta $d018
			lda $dd00
			and #$fc
			ora d1
			eor #3
			sta $dd00
			rts
			
;---------------------------------------------
;void __fastcall__ delay(unsigned char frame);
;---------------------------------------------
			
.export _delay

_delay:			tax
			lda #100
@loop:			jsr _wait
			dex
			bne @loop
			rts

;---------------------------------------------
;void __fastcall__ wait(unsigned char raster);
;---------------------------------------------
			.export _wait

_wait:			cmp $d012
			bne _wait
			rts
;---------------------------------------------
;void __fastcall__ init_msx(unsigned char);
;---------------------------------------------
			.export _init_msx;
_init_msx:		jsr SIDLOADPOS
				rts

	
;---------------------------------------------
;unsigned char random(void);
;---------------------------------------------
	
.export _random

_random:		lda #0
			eor $dc04
			eor $dc05
			eor $dd04
			eor $dd05
			eor $dd06
			eor $dd07
			sta _random+1
			rts
			
;---------------------------------------------
;unsigned char __fastcall__ pet2scr(unsigned char);
;---------------------------------------------
			.export _pet2scr

_pet2scr:		eor #$e0
			clc
			adc #$20
			bpl cont
			adc #$40
			bpl cont
			eor #$a0
cont:		rts

;---------------------------------------------------
;void setup_title_irq(void);
;---------------------------------------------------
;setup the irq runnig in the main menu screen

			.export _title_irq

_title_irq:		sei
			lda #$7f
			sta $dc0d
			sta $dd0d
			lda $dc0d
			lda $dd0d
			lda #1
			sta $d01a
			lda #$1b
			sta $d011

			lda #<title_irq
			ldx #>title_irq
			ldy #$fa
			sta $314
			stx $315
			sty $d012
			asl $d019
			lda #<(scroll_text-1)
			ldx #>(scroll_text-1)
			sta $7a
			stx $7b
			lda #$00
			sta $d020
			sta $d021
			lda #1
			sta $d023
			lda #9
			sta $d022
			lda #0
			sta tmp
			cli
			rts
		
;---------------------------------------------------
;interrupt handler
;---------------------------------------------------

title_irq:
			lda #$f2
			cmp $d012
			bne *-3

			dec scroll
			dec scroll
			lda scroll
			and #7
			sta $d016

			lda $d012
			cmp $d012
			beq *-3
;			lda #0
;			sta $d020
;			sta $d021
;			ldx #7
;barlp:		lda barcolor_tab,x
;			ldy $d012
;			cpy $d012
;			beq *-3
;			sta $d021
;			dex
;			bpl barlp

			lda #$fc
			cmp $d012
			bne *-3
			lda #0
;			sta $d021
			sta $d016
			asl $d019
			;jsr SCROLLCHARS
			jsr SIDPLAYPOS     ; play music
;			dec bar_delay
;			lda bar_delay
;@xyz:		and #1
;			sta bar_delay
;			bne @skip


;			ldx barcolor_tab	;4
;			ldy #0			;2
;@loop:		lda barcolor_tab+1,y	;4
;			sta barcolor_tab,y	;4		;80
;			iny			;6
;			cpy #31			;4
;			bne @loop		;3
;			txa			;2
;			sta barcolor_tab,y	;4		;99

@skip:		lda scroll
			and #7
			bne out2

			ldx #0
gklp:		lda $07c1,x
			sta $07c0,x
			lda $dbc1,x
			sta $dbc0,x
			inx
			cpx #$27
			bne gklp
			inc $7a
			bne *+4
			inc $7b
wrap:		ldy #0
			lda ($7a),y
			bne okok
			lda #<scroll_text
			ldx #>scroll_text
			;ldy #1
			;sty _demo
			sta $7a
			stx $7b
			jmp wrap
okok:		cmp #$10
			bcs okok1
			sta $dbc0+39
			bcc out2
okok1:		jsr _pet2scr
			;ora #$80
			sta $07e7
out2:		lda #<title_irq2
			ldx #>title_irq2
			ldy #$0
out1:		sta $314
			stx $315
			sty $d012
out3:		pla
			tay
			pla
			tax
			pla
			rti

;=========================================
;Scrolling chars in 8 different directions
;=========================================			

SCROLLCHARS:	
			jsr timedirection
			lda animchardelay 
			cmp #$01
			beq selectchartoscroll
			inc animchardelay
			rts 
selectchartoscroll:
			
			lda #$00
			sta animchardelay
			lda animchardirection
			cmp #0
			bne notnorth
			jsr scrollup 
			rts

notnorth:	cmp #1
			bne notnortheast
			jsr scrollup 
			jsr scrollright 
			rts 

notnortheast:
			cmp #2 
			bne noteast 
			jsr scrollright 
			rts 

noteast:	cmp #3
			bne notsoutheast
			jsr scrolldown
			jsr scrollright 
			rts 

notsoutheast:
			cmp #4
			bne notsouth 
			jsr scrolldown 
			rts 

notsouth:	
			cmp #5
			bne notsouthwest 
			jsr scrolldown
			jsr scrollleft
			rts 

notsouthwest:
			cmp #6
			bne notwest 
			jsr scrollleft 
			rts 

notwest:
			cmp #7
			bne notnorthwest 
			jsr scrollleft 
			jsr scrollup 
notnorthwest: 
			rts 


;Time direction of animated charset 

timedirection:
			lda animcharpointer 
			cmp #$ca ;Duration should be long enough here
			beq resetcharanimpointer 
			inc animcharpointer 
			rts 

resetcharanimpointer:
			lda #0 
			sta animcharpointer
			lda animchardirection 
			cmp #7
			beq resetanimcharto0
			inc animchardirection
			rts 
resetanimcharto0:
			lda #0
			sta animchardirection
			rts

scrolldown:
			jsr downlayer1a
			jsr downlayer1b 
			rts 

scrollup:	jsr uplayer1a 
			jsr uplayer1b
			rts 

scrollleft:
			jsr leftlayer 
			rts 
scrollright:
			jsr rightlayer
			rts 

uplayer1a:	lda $2000+(75*8)
			sta chartemp1
			lda $2000+(77*8)
			sta chartemp2
			ldx #$00
uploop1:	lda $2000+(75*8)+1,x 
			sta $2000+(75*8),x 
			inx 
			cpx #$07 
			bne uploop1
			lda chartemp2
			sta $2000+(75*8)+7 
			ldx #$00
uploop2:	lda $2000+(77*8)+1,x 
			sta $2000+(77*8),x 
			inx 
			cpx #$07
			bne uploop2 
			lda chartemp1
			sta $2000+(77*8)+7
			rts 

uplayer1b:	lda $2000+(76*8)
			sta chartemp3
			lda $2000+(78*8)
			sta chartemp4
			ldx #$00
uploop3:	lda $2000+(76*8)+1,x 
			sta $2000+(76*8),x 
			inx 
			cpx #$07
			bne uploop3
			lda chartemp4
			sta $2000+(76*8+7)
			ldx #$00
uploop4:	lda $2000+(78*8+1),x 
			sta $2000+(78*8),x 
			inx 
			cpx #$07 
			bne uploop4
			lda chartemp3
			sta $2000+(78*8)+7
			rts 

downlayer1a:
			lda $2000+(75*8)+7
			sta chartemp1
			lda $2000+(77*8)+7
			sta chartemp2
			ldx #$06 
tiledownloop1:
			lda $2000+(75*8),x 
			sta $2000+(75*8)+1,x 
			dex 
			bpl tiledownloop1
			lda chartemp2
			sta $2000+(75*8)
			ldx #$06 
tiledownloop2:
			lda $2000+(77*8),x 
			sta $2000+(77*8+1),x 
			dex 
			bpl tiledownloop2 
			lda chartemp1
			sta $2000+(77*8)
			rts 

downlayer1b:
			lda $2000+(76*8)+7 
			sta chartemp3
			lda $2000+(78*8)+7 
			sta chartemp4
			ldx #$06
tiledownloop3:
			lda $2000+(76*8),x 
			sta $2000+(76*8)+1,x 
			dex 
			bpl tiledownloop3 
			lda chartemp4 
			sta $2000+(76*8) 
			ldx #$06 
tiledownloop4:
			lda $2000+(78*8),x 
			sta $2000+(78*8)+1,x 
			dex 
			bpl tiledownloop4 
			lda chartemp3
			sta $2000+(78*8)
			rts 

leftlayer:	ldx #$00
scrlefta:	lda $2000+(75*8),x  
			asl 
			rol $2000+(76*8),x 
			rol $2000+(75*8),x 
			inx 
			cpx #$08
			bne scrlefta 
			ldx #$00
scrleftb:	lda $2000+(77*8),x 
			asl 
			rol $2000+(78*8),x 
			rol $2000+(77*8),x 
			inx 
			cpx #$08 
			bne scrleftb
			rts 

rightlayer:	ldx #$00
scright1:	lda $2000+(75*8),x 
			lsr 
			ror $2000+(76*8),x
			ror $2000+(75*8),x 
			inx 
			cpx #$08 
			bne scright1
			ldx #$00
scrright2:	lda $2000+(77*8),x 
			lsr 
			ror $2000+(78*8),x 
			ror $2000+(77*8),x 
			inx 
			cpx #$08 
			bne scrright2 
			rts 

;======================
;COLOUR WASHING ROUTINE
;======================
colwash:    lda colourdelay 
			cmp #$03
			beq colourok 
			inc colourdelay 
			rts 
colourok:	lda #0
			sta colourdelay
			ldx tmp 
			lda colour,x 
			sta $db9f
			sta $db9f+3 
			sta $db9f+11 
			sta $db9f+14 
			sta $db9f+22 
			sta $db9f+25 
			inx 
			cpx #13
			beq resetcolourroutine
			inc tmp
			rts
resetcolourroutine:
			ldx #0
			stx tmp 
			rts 
		    	

title_irq2:	 ;ldx #1
			;lda $d012
			;cmp $d012
			;beq *-3
			;stx $d021
			;ldx #$1b
			;lda $d012
			;cmp $d012
			;beq *-3
			;stx $d011
			;dex
			;stx $d018
			;ldx #3
			;lda $d012
			;cmp $d012
			;beq *-3
			;stx $dd00

			;ldx #8
			;lda #$bc
			;cmp $d012
			;bne *-3
			;stx $d021

			lda #$18
			;ora $d016
			sta $d016
			lda _toggle
			beq @next
			jsr colwash
			jsr SCROLLCHARS
@next:		asl $d019
			lda #<title_irq
			ldx #>title_irq
			ldy #$f1
			sta $314
			stx $315
			sty $d012
			jmp $ea31
			
;---------------------------------------------------------------------------------
;void read_joy(void);
;---------------------------------------------------------------------------------		  
			.export _read_joy
		
_read_joy:			
			lda $dc00 		;read joystick port 2
			lsr       		;get switch bits
			ror cup   		;switch_history = switch_history/2 + 128*current_switch_state
			lsr       		;cupdate the other switches' history the same way
			ror cdown
			lsr
			ror cleft
			lsr
			ror cright
			lsr
			ror button
			
			
			;bit cup       ;check if the joystick has just been moved cup:
            ;bmi jp1   ;if not cup at all
            ;bvc jp1   ;or already cup during the last joystick readout	
            ;jmp movecup ;else it has just been tapped, thus react

;jp1:		bit cdown        
            ;bmi jp2    
            ;bvc jp2   			
			;jmp movecdown
			
jp2:		bit cleft        
            bmi jp3    
            bvc jp3   			
			jmp movecleft

jp3:		bit cright       
            bmi jp4    
            bvc jp4   			
			jmp movecright

jp4:		bit button        
            bmi _read_joy    
            bvc _read_joy
			jmp pressbutton
			
		
;movecup:     
;			lda sprposy
;    		sec
;			sbc #8
;			cmp #49
;			bcc _read_joy
;			sta sprposy
;			sta $d00f
 ;   		jmp _read_joy
					
;movecdown:   lda sprposy
;			clc
;			adc #8
;			cmp #242
;			bcs _read_joy
;			sta sprposy
;			sta $d00f
;			jmp _read_joy 

movecleft:   
			dec _num
			lda _num
			cmp #5
			bcc nxt
			rts
nxt:		lda #5
			sta _num
			rts
			


movecright:   
			inc _num
			lda _num
			cmp #8
			bcs nxt1
			rts
nxt1:		lda #7
			sta _num
			rts

pressbutton: 
			lda _num
			and #%11111011
			sta _num
			rts
			
;---------------------------------------------------------------------------------
;variables, tables, data...
;---------------------------------------------------------------------------------
			
.export _num
_num:			.byte 0

cup:   			.byte 0
cdown:  	    .byte 0
cleft:  		.byte 0
cright:  		.byte 0
button: 	    .byte 0
			
			
scroll:			.byte 0			
bar_delay:		.byte 0	
d1:				.byte 0
tmp:			.byte 0,0,0
count:			.byte 0

charanimdelay: .byte 0
animchardelay:	.byte 0
animchardirection: .byte 0
animcharpointer: .byte 0
chartemp1: .byte 0
chartemp2: .byte 0
chartemp3: .byte 0
chartemp4: .byte 0
colourdelay: .byte 0
.export _toggle
_toggle:         .byte 0		

;barcolor_tab: .byte 2,10, 10,10,10,2,2, 9
;			.byte 8, 8, 7, 7, 7, 7, 8, 8
;			.byte 5, 5,13,13,13,13, 5, 5
;			.byte 6, 6,14,14,14,14, 4,4
			
colour:      .byte 6,2,4,5,3,7,1,7,3,5,4,2,6,0
	
scroll_text:
.byte 2,"welcome to the ",7,"  tower of hanoi 2019 ",3,"            to play use joystick in port 2 ",1
.byte " coded by ",7," matteo angelini ",1," music and graphics from my friend ",7," richard bayliss. ",1,"    as you well know, it is an ancient logic game invented by a french mathematician by name ",7," edouard lucas ",1," in 1883 " 
.byte "       the game supports ",5," up to 8 disks ",1," and provides the ability to automatically resolve the game using a well-known ",5," function recursion algorithm     "
.byte 1," the objective of the puzzle is to move the entire stack to another rod, obeying the following simple rules: "
.byte " 1) only one disk can be moved at a time. "
.byte " 2) each move consists of taking the upper disk from one of the stacks and placing it on top of another stack or on an empty rod."
.byte " 3) no larger disk may be placed on top of a smaller disk.  "
.byte 8," technical information: ",1," the game has 2 modes: ",10," 1) player mode 2) self-resolving mode. "
.byte 1," the player mode requires the use of the joystick in port 2. the self-resolving mode can be ",5," slow or fast. "
.byte 1," each time a new game starts, a timer count the elapsed time, once the game is completed the time taken and the total moves will be shown.  "
.byte 0











